﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@
' =======================================================================================
' Description ...: Form Generator
' Requirement(s).: Basic4Android 9.00
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.8.8
' Date...........: 17 December 2019
' License........: Free to use without any warranties
' =======================================================================================
'Class module
Sub Class_Globals
	Dim fh_Data As Map = CreateMap()		' Reference to widget of data
	Dim fh_FieldsType As Map = CreateMap()	' Reference to fields type
	Dim numericTypes As Map = CreateMap("N":True,"DN":True,"IN":True,"S":True)	' widgets with numeric values
	Dim comparator As Map = CreateMap("=":1,">":2,"<":4,">=":3,"<=":5,"<>":6)
	Dim defLength As Map = CreateMap("S":5,"QS":8,"F":30,"DN":9,"N":8,"IN":7,"P":16,"R":12,"I":0,"DATE":12,"TIME":10,"TITLE":"","C":40)
	Dim normType As Map = CreateMap("HIDDEN":"H","IMAGE":"I","BACKGROUND":"GROUND","DEFAULTS":"DEFAULT","RDEFAULTS":"RDEFAULT","COMMENT":"C")
	Dim colorsMap As Map = CreateMap("red":Colors.red,"green":Colors.green,"blue":Colors.blue, "magenta":Colors.Magenta, _
							"yellow":Colors.Yellow,"gray":Colors.Gray,"lightgray":Colors.LightGray,"cyan":Colors.Cyan, _
							"black":Colors.Black,"teal":Colors.RGB(0,127,127),"white":Colors.White, _
							"olive":Colors.RGB(127,127,0),"aqua":Colors.RGB(0,255,255),"orange":Colors.RGB(255,165,0), _
							"silver":Colors.RGB(192,192,192),"crimson":Colors.RGB(220,20,60), "purple":Colors.RGB(128,0,128))
	'	1 Text
	'		16384	Cap sentences
	'		128		password
	'		131072	multiline
	'	2 Number
	'		4096	signed
	'		8192	decimal
	'	4 Date
	'		16		date
	'		32		time
	Dim Version As String = "Version 0.8.7 17 December 2019"
	Dim textAttributes As Map = CreateMap("DATE":Bit.Or(4,16),"DN":Bit.Or(2,Bit.Or(4096,8192)),"P":Bit.Or(1,128), _
										"N":Bit.Or(2,4096),"IN":2,"S":Bit.Or(2,4096),"TIME":Bit.Or(4,32))
	Dim fh_yesToExit As Boolean = True	' used for block exit
	Dim fhMap_ColorDrawable As Map = CreateMap()
	Private fh_module As Object	' calling Module
	Private fh_returnSub As String	' receiving sub
	Private fh_handleSub As String	' handle events sub
	Private fh_panel As Panel	' Reference to panel handle
	Private fh_panels(10) As Panel	' for TAB
	Dim fh_groundPanel As ScrollView
	Private nTabs As Int
	Dim customOkButton As Boolean ' true Ok button isn't generate
	Private currentTab As Int
	Private heightHeadTab As Int = 50dip
	Private dimLabel(10) As Int
	Type tabAttrib(lbl As Label, caption As String, ground As String, height As Int)
	Private tabAttribs(10)	As tabAttrib
	Dim baseHeight As Int = 48/1dip
	Dim widgetRef As Map		' Reference to widget of data
	Private Elem As Map			' data fields
	Private Defaults As Map		' fields defaults
	Private ground As String	' contains ground
	Private tipsMap As Map		' tooltips Map, key is field name
	Private checks As Map		' checks on wiew, key is field name
	Private after As Map		' after key is view to set after value
	Dim nElem As Int			' Elements number
	Dim Limits As Map			' for numerics fields
	Dim mapValues As Map		' combo/radio key value
	Dim hiddensMap As Map		' Hidden values
	Dim field() As String
	Dim charPerRow As Int		' maximum widget width
	Dim charHeight As Float		' height for 12 
	Dim pnl As Panel
	Dim offsetButtons As Int	' for center buttons
	Dim btn As Button
	Dim btnWidth As Int = 70dip
	Dim Matcher1 As Matcher
	Dim Sections(1,3) As String	' sections array
	Dim Section As Int = -1		' actual section
	Dim act As Activity
'	Dim VR As VoiceRecognition
'	VR.Initialize("VR")
	Private focusTxt As EditText
	Dim typeForm As String	' typeForm: T = text, B = buttons, C = combo box (spinner)
	Dim backgroundDrawable As ColorDrawable
	Public re As String = "^\s*([-+]?\d+)\s+([-+]?\d+)\s*$"	' for caputure n1 n2 (ex -100 100)
	Public labels(3) As Object	' eventual label (label,gravity,pixel dimension)
'   window size
	Dim wTop, wLeft, wWidth, wHeight As Int
	Dim padding() As Int = Array As Int(4dip,5dip,2dip,0dip)	' for texts and spinners
	Dim spinnerPadding() As Int = Array As Int(4dip,1dip,2dip,0dip)	' for texts and spinners
	Dim border As String
'	Regular expressions
	Public reTime As String = "\s*|^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]:[0-5][0-9]$"
	Public reMail As String = "^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$|\s*"
	Public reCheckOperands As String = ".+\s*(=|<=|>=|<>|>|<|is)\s*(.*)"
	Public reHexaDecimal As String = "^[\daAbBcCdDeEfF]{1,8}$"
	Public reDeMask As String = "#\d+|#[xX][aAbBcCdDeEfF\d]+" 'one or more digits
	Dim fh_isRunning As Boolean
'	tuning parameters 
	Dim borderLineWidth As Int = 3dip
	Dim shadowWidth As Int = 10dip
	Dim deltaY As Int = 40dip				' standard widget distance
	Dim widgetHeight As Int = deltaY*0.75	' standard widget height
End Sub
Public Sub Initialize
End Sub
Sub fgw(activ As Activity,params As String,Module As Object,handleSub As String)	' for hanle data in the same calling sub	
	fg(activ,params,Module,"",handleSub)	
End Sub
Sub fg(activ As Activity,params As String,Module As Object,retSub As String,handleSub As String)
	fh_isRunning = True
	fh_returnSub = retSub
	fh_handleSub = handleSub
	fh_module = Module
	labels = Array("",Gravity.LEFT,6dip)
	act = activ
	Dim prefix As String = ""
	Dim MatchSection As Matcher = Regex.Matcher2("(.*?);(Section,.*)",Regex.CASE_INSENSITIVE,params)
	Dim beforeSection As String = ""
	If MatchSection.Find Then
		beforeSection = MatchSection.Group(1) & ";"
		params = MatchSection.Group(2)
	End If	
	If Not(Regex.IsMatch2("^\s*section.*",Regex.CASE_INSENSITIVE,params)) Then prefix = "Section,;"
	Dim s() As String = Regex.split2(";*\s*section,",Regex.CASE_INSENSITIVE,prefix & params.Replace(Chr(10),""))
	Dim Sections(s.Length-1,3) As String
	For i = 1 To s.Length -1
		Matcher1 = Regex.Matcher("(.*?);(.*)",s(i))
		If Matcher1.Find Then
			Dim sectorParm() As String = Regex.Split(",",Matcher1.Group(1))	' force three fields
			Sections(i-1,0) = beforeSection & Matcher1.Group(2)	' prefixed by possibly views commons to all sections
			' this above for possibly lack of title, i.e. title from section name
			If beforeSection <> "" Then
				If sectorParm(0) <> "" Then Sections(i-1,0) = beforeSection & ";Title,fh_section" & i & "," & sectorParm(0) & ";" & Matcher1.Group(2)
			End If
			Sections(i-1,1) = sectorParm(0)		' section name
			Sections(i-1,2) = implodeFrom(",",sectorParm,1,sectorParm.Length-1)	' check conditions
		End If
	Next
	fh_Data.Clear
	fh_FieldsType.Clear
	Section = -1
	CallSubDelayed2("","fh_answer",fh_Data)
End Sub
Sub fh_answer(Data As Map)
	nTabs = 0
	currentTab = 1
	dimLabel(0) = 0
	Dim button As String = Data.GetDefault("fh_button","First stroke")
	If button = "Cancel" Then
		fh_isRunning = False
		Section = -1
		fh_Data = CreateMap("fh_button":"Cancel")
		If fh_returnSub = "" Then Return
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
	Else
		Section = iIF(button = "fh_Back",Section - 1,Section + 1)
		If Section >= Sections.Length Then
			Section = -1
			fh_isRunning = False
			If fh_returnSub = "" Then Return
			CallSubDelayed2(fh_module,fh_returnSub,Data)		
		Else
			' check if section is conditioned
			Dim conditions() As String = Regex.Split(",",Sections(Section,2))
			Dim condition As Boolean = True
			For i = 0 To conditions.Length - 1
				Matcher1 = Regex.Matcher("(.+?)\s*(=|<=|>=|<>|>|<)\s*(.*)",conditions(i))
				If Not(Matcher1.Find) Then Continue
				Dim fieldName As String = Matcher1.Group(1)
				If Not(compare(numericTypes.GetDefault(fh_FieldsType.GetDefault(fieldName,False),False),fh_Data.GetDefault(fieldName,""),Matcher1.Group(2),deMask(Matcher1.Group(3)))) Then
					condition = False
				End If
			Next
			If condition Then
				CallSubDelayed2("","fgSection", Sections(Section,0))
			Else
				CallSubDelayed2("","fgSection","")	' this because there is not goto
			End If
		End If
	End If
End Sub
Sub fgSection(params As String)
	If params = "" Then	' this because there is not goto
		CallSubDelayed2("","fh_answer",fh_Data)
		Return
	End If
	widgetRef.Initialize
	Elem.Initialize
	tipsMap.Initialize
	checks.Initialize
	Limits.Initialize
	mapValues.Initialize
	Defaults.Initialize
	hiddensMap.Initialize
	after.Initialize
	wLeft = 0
	wTop = 0
	wWidth = 100%x
	wHeight = 100%y
	border = ""
	Dim cmb As Spinner
	Dim rdb As RadioButton
	Dim widgets() As String
	Dim dummy,width,offsetX, offsetY As Int
	Dim wdgType As String
	Dim allButtons As Map = CreateMap()
	customOkButton = False	' true Ok button isn't generate 
	Dim fromTo() As String	' array for limits (used also for ground colors and defaults)
	offsetX = 2%x
	width = 50dip	' used fror slider (ll slider is 3 * width)
	widgets = Regex.Split(";\s*",params)
	Dim sSelector As Int = 28dip	' spinner selector right position
	Dim c As Canvas
	c.Initialize(act)
	Dim charWidth As Float = c.MeasureStringWidth("EepgAaSsIimw09",Typeface.DEFAULT,12)/14
	Dim s As String = "Epqy"
	charHeight = 1dip * c.MeasureStringHeight(s,Typeface.DEFAULT,12)
	' normalize request: control and clean parameters
	ground = "FF404040 FF404040"	' default gradient
	Private title As String	= ""
' create triangle ----------------------------------------------------------------------------
	Private triangle As Bitmap = createTriangle(widgetHeight,widgetHeight)	' for spinners
' check parameters ---------------------------------------------------------------------------
	For iw = 0 To widgets.Length - 1
		If Left(widgets(iw),1) = "'" Or widgets(iw) = "" Then Continue	' comment
		field = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""		' remove *
		field(0) = normType.GetDefault(field(0).ToUpperCase,field(0).ToUpperCase)	' upper case and synonim
		Select field(0)
			Case "DEFAULT", "RDEFAULT"				' defaults view
				For ir=1 To field.Length - 1
					If field(ir) <> "" Then
						fromTo = Regex.split("\s*:",field(ir) & ":")
						If field(0) = "RDEFAULT" Then fromTo = extractRandom(fromTo)
						If fromTo.Length = 2 Then Defaults.Put(fromTo(0),deMask(fromTo(1)))
					End If
				Next			
			Case "REQUIRED"					' required view
				For ir=1 To field.Length - 1
					addCheck(field(ir) & " is required","required")
				Next
			Case "H"						' Hiddens fields
				hiddensMap.Put(field(1),implodeFrom(",", field,2,100))
				widgetRef.Put(field(1),Array As Object (0,"H",0,0,0))
			Case "CHECK"					' checks on fields
				addCheck(field(1),field(2))
			Case "AFTER"					' after
				If Not(fh_FieldsType.ContainsKey(field(1))) Then
					Msgbox("View " & field(1) & " not exists!","After ignored")
				Else
					If Not(fh_FieldsType.ContainsKey(field(2))) Then
						Msgbox("View " & field(2) & " not exists!","After ignored")
					Else
						after.Put(field(1),field(2))
					End If
				End If
			Case "GROUND"				' Background
				If nTabs = 0 Then 
					ground = field(1)	' global ground
				Else
					tabAttribs(nTabs).ground = field(1)
				End If
			Case "LABEL"
				labels(0) = field(3)	' text after label
				If field(2).ToUpperCase = "RIGHT" Then labels(1) = Gravity.RIGHT
				labels(2) = c.MeasureStringWidth(labels(0),Typeface.DEFAULT,12) + 6dip
			Case "WINDOW"
				If field(1) <> "" Then wWidth = 100%x * field(1) / 100 
				If field(2) = "" Then
					wHeight = 0
				Else
					wHeight = 100%y * field(2) / 100
				End If
				If field(3) <> "" Then wLeft = 100%x * field(3) / 100
				If field(4) <> "" Then wTop = 100%y * field(4) / 100
				If wWidth <> 100%x And field(3) = "" Then wLeft = 0.5 * (100%x - wWidth)
				If wHeight > 0 And field(4) = "" Then 
					wTop = 0.5 * (100%y - wHeight)
				Else
					If field(4) = "" Then wTop = -1	' is set when wHeight is known for center
				End If
				border = field(5).ToLowerCase
			Case Else
				If field(0) = "TAB" Then
					nTabs = nTabs +1
					If field(1) = "" Then field(1) = "fh_tab" & nTabs	' if name lacks
					field(2) = deMask(field(2))
					dimLabel(nTabs) = 0
					tabAttribs(nTabs).lbl = Createlabel(field(2),14,"onglets")
					tabAttribs(nTabs).caption = field(2)
					tabAttribs(nTabs).height = 0
					tabAttribs(nTabs).ground = ground
					tabAttribs(nTabs).lbl.Tag = nTabs
				else If field(0) = "TITLE" Then		' title
					title = field(1) & "/" & deMask(field(2)) & "/" & field(3) & "/" & field(4)	'  save for possible tab
				Else If field(0) = "TIME" Then
					addCheck(field(1) & " is " & reTime,"Incorrect time")
				Else If field(0) = "I" Then		' Image rearrange data
					field(5) = field(3)			' left on extra
					field(3) = field(2)			' width on length
				End If
				If field(2) = "" Then field(2) = field(1)	' if there is not label
				If field(1) = "" Then field(1) = "fh_widget" & Elem.Size	' if name lacks
				If field(0) = "" Then field(0) = "T"
				If field(0) = "C" Or field(0) = "I" Then field(2) = ""		' ignore comment and image label
				field(2) = deMask(field(2))
				field(4) = deMask(field(4).Trim())
				field(5) = deMask(field(5))
				If field(3) = "" Then field(3) = defLength.GetDefault(field(0),Max(20,field(4).Length))
				If Not(Defaults.ContainsKey(field(1))) Then 
					Defaults.Put(field(1),field(4))	' set defaults map
				End If
				If field(0) = "S" Then
					If field(5) = "" Then field(5) = "0 100"	' default slide
					fromTo = Regex.split(" ",field(5))
					Limits.Put(field(1) & "Min",fromTo(0))
					Limits.Put(field(1) & "Max", 100)
					If fromTo.Length = 2 Then Limits.Put(field(1) & "Max",fromTo(1))
					Limits.Put(field(1) & "Delta", Limits.get(field(1) & "Max") - Limits.get(field(1) & "Min"))
				End If
				If Not("B*C*TAB*TITLE*I*".Contains(field(0) & "*")) Then	' label dimension
					dummy = 3dip + c.MeasureStringWidth(field(2),Typeface.DEFAULT,12)
					If dummy > dimLabel(nTabs) Then dimLabel(nTabs) = dummy
				End If
					Elem.Put(field(1),field)
					fh_FieldsType.Put(field(1),field(0))	' for type numeric or string
			End Select
	Next
	Dim panelHeight As Int = 0
	If nTabs > 0 Then
		Dim labelTabsWidth As Int = (wWidth-10)/nTabs	' for possible shadow
	End If
	If dimLabel(nTabs) > 50%x Then dimLabel(1) = 50%x
	nElem = Elem.Size
	typeForm = ""				' for type of final buttons
	' create form -------------------------------------------------------------------------------------
	offsetY = iIF(title = "", 5dip,40dip)
	Dim tabsTop As Int = offsetY	' tabs labels
	fh_groundPanel.Initialize(100%y)	' panel container
	fh_panel.Initialize("")
	nTabs = 0
	For ck = 0 To nElem - 1
		Dim widgetPosition As Int = offsetX + dimLabel(nTabs) + labels(2)
		charPerRow = Ceil((100%x - 2*offsetX - widgetPosition - iIF(nTabs > 0,20dip,0)) / charWidth)
		field = Elem.GetValueAt(ck)
		wdgType = field(0)
		If wdgType = "TITLE" Then		' title
			Continue
		else If wdgType = "TAB" Then
			If nTabs > 0 Then
				If offsetY > panelHeight Then panelHeight = offsetY
				tabAttribs(nTabs).height = offsetY
			End If
			offsetY = iIF(title = "", 5dip,deltaY) + heightHeadTab
			nTabs = nTabs + 1
			fh_panels(nTabs).Initialize(100%y)
			fh_panel = fh_panels(nTabs)	' *** *** 14/11/19
			Continue
		End If
		Dim textHeight As Int = getHeight(Ceil(field(3)/charPerRow))	' height for view
		Dim itemHeight As Int = widgetHeight	' height for view
		Dim lbl As Label = Createlabel(field(2) & labels(0),12,"")		' possible extra characters
		lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL,  labels(1))
		lbl.Tag = field(1)	' fieldName
		Dim txtProto As EditText
		If wdgType = "B" Then
			If after.ContainsKey(field(1)) Then
				genAfterButton(field)
			Else
				widgetRef.Put(field(1),Array As Object (0,"B",0,field(5),nTabs))
				allButtons.Put(field(1),Array As String (field(2) , field(5)))
				customOkButton = True
			End If
			Continue
		Else If wdgType = "CKB" Then
			Dim ckbProto As CheckBox
			ckbProto.Initialize("checkBox")
			ckbProto.TextSize = 12
			ckbProto.text = " " & field(5)
			ckbProto.Tag = field(1)
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				If field(5) = "" Then ckbProto.text = " " & field(2)	' label instead 29 4 2019
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
				fh_panel.AddView(ckbProto,afterView.Left+afterView.Width+10, afterView.Top , field(3) * charWidth, deltaY-4dip)
				topAfterView(afterView,ckbProto)
			Else
				fh_panel.AddView(ckbProto,widgetPosition, offsetY, field(3) * charWidth, widgetHeight)
			End If
			widgetRef.Put(field(1),Array As Object (ckbProto,wdgType,lbl,0,0))
		Else If wdgType = "R" Then			' *** Radiobuttons
			Dim rdbList As List,j As Int
			rdbList = splitKeyValue(field(1),field(5))
			pnl.Initialize("")
			widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,0,0))
			For j = 0 To rdbList.Size-1
				rdb.Initialize("RadioButton")
				rdb.TextSize = 12
				rdb.text = rdbList.get(j)
				rdb.Tag = field(1)
				pnl.AddView(rdb,j*field(3) * charWidth,0dip,field(3) * charWidth, getHeight(1))
				If rdbList.get(j) = field(4) Then widgetRef.Put(field(1),Array As Object (pnl,wdgType,lbl,rdb,0))	' default
				If File.Exists(File.DirAssets,rdb.text) Then ' grafic button
					Dim gBtn As ImageView = fg_createButtonImage(rdb.text,"RDBbuttons")
					Dim wh() As String = Regex.Split("x",gBtn.Tag)
					gBtn.Tag = rdb			
					pnl.AddView(gBtn, 35dip + j*field(3) * charWidth,1dip,wh(0)+10dip, wh(1)+10dip)
					rdb.width = 28dip
				End If
			Next
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)			
				fh_panel.AddView(pnl,afterView.Left+afterView.Width+10dip, afterView.Top, field(3) * charWidth, afterView.height)
				topAfterView(afterView,pnl)
			Else
				If field(1) = "Align" Then
'					Log("************** " & field(1))
				End If
				fh_panel.AddView(pnl,widgetPosition, offsetY, field(3) * charWidth, widgetHeight)
			End If
			pnl.width = 90%x
		Else If "*CMB*CMX*CMT*F*".Contains("*" & wdgType & "*") Then		' *** ComboBox (spinner) and File
			cmb.Initialize("combos") 'All combos share the same event sub
			cmb.TextSize = 12
			cmb.Padding = spinnerPadding
			backgroundDrawable.Initialize(Colors.ARGB(63,255,255,255), 3dip)
			fhMap_ColorDrawable.Put(field(1),backgroundDrawable)
			cmb.Background = fhMap_ColorDrawable.get(field(1))
			Dim yText As Int = offsetY
			Dim ySpinner As Int = offsetY
			If wdgType = "CMT" Then 
				ySpinner = offsetY+textHeight + 2dip
				itemHeight = itemHeight + textHeight
			End If
			If wdgType = "CMX" Then 
				itemHeight = itemHeight + textHeight
				yText = offsetY+getHeight(1) + 1dip
			End If
			Dim cmbWidth As Int = Min(field(3),charPerRow) * charWidth
			fh_panel.AddView(cmb,widgetPosition, ySpinner, cmbWidth, widgetHeight)
			Dim labTdown As Label = Createlabel("",12,"")
			labTdown.SetBackgroundImage(triangle)
			fh_panel.AddView(labTdown,cmb.Left+cmb.Width-sSelector, cmb.top, sSelector, cmb.height)
			cmb.Tag = field(1)
			If wdgType <> "F" Then
				cmb.addall(splitKeyValue(field(1),field(5)))
				cmb.Prompt = field(2)	' the label is prompt
			Else
				Dim lblFile As Label = Createlabel("",8,"")
				Dim lblFileLeft As Int = cmb.Left+cmb.width + 1dip
				fh_panel.AddView(lblFile,lblFileLeft, cmb.top, 100%x-lblFileLeft-10dip, cmb.height)
				tipsMap.Put(field(1),lblFile)
			End If
			widgetRef.Put(field(1),Array As Object (cmb,wdgType,lbl,"",0))
			If wdgType = "CMT" Or wdgType = "CMX" Then		' combo + text added
				CreateText(txtProto,field)
				widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,cmb,0))
				fh_panel.AddView(txtProto,widgetPosition , yText, iIF(field(3) > charPerRow, charPerRow,field(3)) * charWidth, getHeight(Ceil(field(3)/charPerRow)))
			End If
		Else If wdgType = "U" Then
			Dim uLbl As Label = Createlabel(field(4),12,"")
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
				fh_panel.AddView(uLbl,afterView.Left+afterView.Width+10dip, afterView.top,field(3) * charWidth, deltaY-2dip)
				topAfterView(afterView,uLbl)
			Else
				fh_panel.AddView(uLbl,widgetPosition, offsetY+1dip, iIF(field(3) > charPerRow, charPerRow,field(3)) * charWidth, getHeight(Ceil(field(3)/charPerRow)))
			End If
			widgetRef.Put(field(1),Array As Object (uLbl,wdgType,lbl,uLbl,0))
		Else If wdgType = "C" Then	' comment
			Dim uLbl As Label = Createlabel(field(4),12,"")
			Dim lst As List  = Regex.split(Chr(10),field(4))
			Dim rows As Int = 0
			For i = 0 To lst.size - 1
				Dim row As String = lst.Get(i)
				rows = rows + Ceil(c.MeasureStringWidth(row,Typeface.DEFAULT,12)/wWidth)
			Next
			itemHeight = getHeight(rows)
			fh_panel.AddView(uLbl,offsetX, offsetY, 0.9*wWidth, itemHeight)
			widgetRef.Put(field(1),Array As Object (uLbl,wdgType,uLbl,uLbl,0))
		Else If wdgType = "I" Then	' Image
			Dim img As ImageView = createImage(fh_panel,field(1),iIF(field(3) = "",-1,field(3)),iIF(field(5) = "",-1,field(5)),offsetY)
			borders(img,field(4))	' possible border/shadow
			itemHeight = img.Height + 0.1*deltaY
		Else
			itemHeight = textHeight
			CreateText(txtProto,field)
			If "*DN*N*IN*S".Contains("*" & field(0)) Then txtProto.Gravity = Gravity.Right	' numerics fields
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lbl,txtProto,0))
			If wdgType = "S" Or wdgType = "QS" Then		' *** slide ***
				Dim sldProto As SeekBar
				sldProto.Initialize("Slide")
				sldProto.Tag = field(1)	' widget name
				widgetRef.Put(field(1),Array As Object (sldProto,wdgType,lbl,txtProto,0))
				If wdgType = "QS" Then	' *** qualitative slide ***
					txtProto.Enabled = False
					Private listSQ As List = splitKeyValue(field(1),field(5))
					Limits.Put(field(1),listSQ)
					sldProto.Max = listSQ.Size - 1
				Else
					If Abs(Limits.get(field(1) & "Delta")) < width*2.5 Then txtProto.Enabled = False				
				End If
				fh_panel.AddView(sldProto,widgetPosition, offsetY, width*3, deltaY*0.7)
				fh_panel.AddView(txtProto,sldProto.Left+sldProto.Width-5dip, offsetY, field(3) * charWidth, getHeight(1))
			Else	' this is a text field I suppose
				txtProto.HintColor = Colors.LightGray
				txtProto.Hint = field(5)
				If field(6) <> "" Then tipsMap.Put(field(1),deMask(field(6)))			
				If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
					If field(5) <> "" Then lbl = Createlabel(field(5) & labels(0),12,"")
					Dim afterView As View = getFromViewMap(after.Get(field(1)),0)
					fh_panel.AddView(lbl,afterView.Left+afterView.Width+10, afterView.Top +2dip, 6dip+(field(2) & labels(0)).Length * charWidth, deltaY-4dip)
					fh_panel.AddView(txtProto,lbl.Left+lbl.Width,afterView.Top, iIF(field(3) > charPerRow, charPerRow,field(3)) * charWidth, textHeight)
				Else
					fh_panel.AddView(txtProto,widgetPosition , offsetY, iIF(field(3) > charPerRow, charPerRow,field(3)) * charWidth, textHeight)
				End If			
			End If
		End If
		If wdgType = "CMB" Then 
			typeForm = typeForm & "C"
		Else
			If wdgType <> "I" And wdgType <> "C" Then 
				typeForm = typeForm & wdgType
			End If
		End If
		setInMap(field(1),4,nTabs)	' tab position
		If Not(after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1)))) Then
			If wdgType <> "C" Then 
				fh_panel.AddView(lbl,offsetX, offsetY, dimLabel(nTabs)+labels(2), widgetHeight)
				lbl.Top = offsetY+(itemHeight - lbl.Height)*0.5
				lbl.Invalidate
			End If
			offsetY = offsetY + itemHeight +10dip
		End If
	Next
	If nTabs > 0 Then 
		tabAttribs(nTabs).height = offsetY	' last tabs height
		If offsetY > panelHeight Then panelHeight = offsetY	' last tabs height
		panelHeight = panelHeight + heightHeadTab
	Else 
		panelHeight = offsetY
	End If
	' what buttons?
	If typeForm <> "C" And nTabs = 0 Then ' if no only one spinner
		Dim pnlButtons As Panel = createPanelButtons(allButtons,0)
		fh_panel.AddView(pnlButtons,offsetButtons,panelHeight,pnlButtons.width,deltaY)
		panelHeight = panelHeight + deltaY
	End If
	If border <> "" Then panelHeight = panelHeight + shadowWidth
	If wHeight = 0 Then wHeight = panelHeight
	If title <> "" Then
		Dim lblTitle As Label = createTitle(title)
		If nTabs = 0 Then
			fh_panel.AddView(lblTitle,0, 0, wWidth, deltaY)	' title is in form panel
		Else
			fh_groundPanel.Panel.AddView(lblTitle,0, 0, wWidth-10, deltaY)	' title is in ground panel and possible shadow
		End If
	End If
	If nTabs > 0 Then
		pnl.Initialize("")	' container for tabs labels
		For jk = 1 To nTabs
			Dim pnlButtons As Panel = createPanelButtons(allButtons,jk)
			fh_panels(jk).Background = createGradient(tabAttribs(jk).ground)
			If jk > 1 Then fh_panels(jk).Visible = False
			fh_panels(jk).AddView(pnlButtons,offsetButtons,tabAttribs(jk).height,pnlButtons.width,deltaY)
			tabAttribs(jk).lbl.Text = CreateCSLabel(tabAttribs(jk).caption,iIF(jk = 1,True,False))
			pnl.Color =Colors.Gray
			pnl.AddView(tabAttribs(jk).lbl,labelTabsWidth*(jk-1),0,labelTabsWidth,deltaY)
			fh_panels(jk).Height = panelHeight
			fh_panels(jk).width = wWidth
			Dim x As Int = borders(fh_panels(jk),border)
			fh_groundPanel.Panel.AddView(fh_panels(jk),0,0,wWidth,panelHeight)
		Next
		fh_groundPanel.Panel.AddView(pnl,3dip,tabsTop,wWidth-iIF(x>0,iIF(x=1,6dip,16dip),6dip),deltaY)
		Dim buttonPosition As Int = wWidth-2.2*btnWidth
		If allButtons.ContainsKey("Ok") Then
			Dim k() As String = allButtons.Get("Ok")
			btn = fg_CreateButton("Ok",k(0),12,"buttons")
			widgetRef.Put("Ok",Array As Object (btn,"B",0,k(1),0))
			fh_groundPanel.Panel.AddView(btn,buttonPosition,panelHeight+2dip,btnWidth, deltaY-8dip)
		End If
		k = allButtons.Get("Cancel")
		btn = fg_CreateButton("Cancel",k(0),12,"buttons")
		widgetRef.Put("Cancel",Array As Object (btn,"B",0,k(1),0))
		fh_groundPanel.Panel.AddView(btn,buttonPosition+btnWidth,panelHeight+2dip,btnWidth, deltaY-8dip)
		panelHeight = panelHeight+deltaY	' for buttons
	Else
		fh_panel.Background = createGradient(ground)
		fh_panel.width = wWidth		' needs set for border
		fh_panel.height = panelHeight	' needs set for border
		borders(fh_panel,border)
	End If
	If nTabs > 0 Then wHeight = wHeight + deltaY
	If wTop = -1 Then wTop = Max(0,0.5 * (100%y - wHeight))
	If panelHeight > wHeight Or panelHeight > 100%y Then
		If nTabs = 0 Then
			fh_groundPanel.Panel.AddView(fh_panel,0,0,wWidth,panelHeight)
			fh_groundPanel.panel.Height = panelHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,wHeight)
		Else
			fh_groundPanel.panel.Height = panelHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,100%y-wTop)
		End If
	Else
		If nTabs > 0 Then 
			fh_groundPanel.panel.Height = wHeight
			act.AddView(fh_groundPanel,wLeft,wTop,wWidth,wHeight)
		Else
			act.AddView(fh_panel,wLeft,wTop,wWidth,wHeight)
		End If
	End If
	If title <> "" Then lblTitle.BringToFront
	setDefaults(0)
	handleEvents(Array As Object ("fh_start","Start"))
	If nTabs > 0 Then handleEvents(Array As Object ("TAB0","OPEN",""))
End Sub
Sub genAfterButton(f() As String)
	If File.Exists(File.DirAssets,f(2)) Then ' grafic button
		Dim afterBtn As View = fg_createButtonImage(f(2),"buttons")
		Dim wh() As String = Regex.Split("x",afterBtn.Tag)
		afterBtn.Tag = f(1)
		wh(0) = wh(0)+20dip
		wh(1) = wh(1)+13dip
	Else
		Dim afterBtn As View = fg_CreateButton(f(1),f(2),12,"buttons")
		Dim wh(2) As String = Array As String(btnWidth,deltaY-8dip)
	End If
	Dim afterView As View = getFromViewMap(after.Get(f(1)),0)
	Dim panelAfterView As Panel = afterView.parent
	panelAfterView.AddView(afterBtn,afterView.Left+afterView.Width+10dip, afterView.Top, wh(0), wh(1))
	topAfterView(afterView,afterBtn)
	widgetRef.Put(f(1),Array As Object (afterBtn,"B",0,f(5),nTabs))
End Sub
Sub fg_CreateButton(Name As String, txt As String,fSize As Int, handle As String) As Button
	Dim btnX As Button
	btnX.Initialize(handle)
	CreateButton(btnX,Name,txt,fSize)
	Return btnX
End Sub
Sub createPanelButtons(allButtons As Map,tabNumber As Int) As Panel
	Dim pnlButtons As Panel		' panel for buttons
	pnlButtons.Initialize("")
	If Section > 0 Then 
		allButtons.Put("fh_Back",Array As String("<--",""))
		widgetRef.Put("fh_Back",Array As Object (0,"B",0,"",0))
	End If
	If Not(allButtons.ContainsKey("Cancel")) Then allButtons.put("Cancel",Array As String("Cancel",""))
	If Not(Regex.IsMatch("U+",typeForm) Or typeForm = "") Then
		If Not(allButtons.ContainsKey("Reset")) Then allButtons.put("Reset",Array As String("Reset",""))
		If Not(customOkButton) Then 
			allButtons.put("Ok",Array As String("Ok",""))
			widgetRef.Put("Ok",Array As Object (0,"B",0,"",0))
		End If
	End If
	If Sections.Length > 1  Then
		If Section < Sections.Length -1 Then
			allButtons.put("fh_Forward",Array As String("-->",""))
			widgetRef.Put("fh_Forward",Array As Object (0,"B",0,"",0))
		End If
		If Section <> Sections.Length - 1 Then allButtons.Remove("Ok")
	End If
	Dim j As Int = 0
	For i = 0 To allButtons.Size - 1
		Dim Name As String = allButtons.GetKeyAt(i)
		Dim tabPosition As Int = getFromViewMap(Name,4)
		If Name <> "Reset" And tabPosition <> tabNumber Then Continue
		Dim k() As String = allButtons.GetValueAt(i)
		If File.Exists(File.DirAssets,k(0)) Then ' grafic button
			Dim gBtn As ImageView = fg_createButtonImage(k(0),"buttons")
			Dim wh() As String = Regex.Split("x",gBtn.Tag)
			pnlButtons.AddView(gBtn,j*btnWidth+(btnWidth-gBtn.Width)*0.5,0, wh(0)+20dip,Max(deltaY,wh(1)+10dip))
			gBtn.Tag = Name
			setInMap(Name,0,gBtn)
		Else
			btn = fg_CreateButton(Name,k(0),12,"buttons")
			pnlButtons.AddView(btn,j * btnWidth,0,btnWidth, deltaY-8dip)
			setInMap(Name,0,btn)
		End If
		j = j + 1
	Next
	offsetButtons = (wWidth - j * btnWidth) * 0.5
	pnlButtons.Width = j*btnWidth
	Return pnlButtons
End Sub
Sub CreateButton(btnX As Button,Name As String, txt As String,fSize As Int)
	btnX.Padding = Array As Int (0dip, 0dip, 0dip, 0dip)
	btnX.TextSize = fSize
	btnX.Text = txt
	btnX.Tag = Name
	Dim cdwBtnEnabled As ColorDrawable	' Define a color for Enabled state
	cdwBtnEnabled.Initialize2(Colors.Gray,10,1dip,Colors.ARGB(127,15,15,15))
	Dim cdwBtnPressed As ColorDrawable	' Define a color for Pressed state
	cdwBtnPressed.Initialize2(Colors.LightGray,10,1dip,Colors.ARGB(127,15,15,15))
	Dim btnStateList As StateListDrawable	' Define a StateListDrawable
	btnStateList.Initialize
	Dim states(2) As Int
	states(0) = btnStateList.state_enabled
	states(1) = -btnStateList.state_pressed
	btnStateList.addState2(states, cdwBtnEnabled)
	Dim states(1) As Int
	states(0) = btnStateList.state_pressed
	btnStateList.addState2(states, cdwBtnPressed)
	btnX.Background = btnStateList	' Set btnStateList to button background
End Sub
Sub fg_createButtonImage(imgFile As String,eventHandler As String) As ImageView
	Dim gBtn As ImageView
	gBtn.Initialize(eventHandler)
	gBtn.Padding = Array As Int (0dip, 0dip, 0dip, 0dip)
	Dim x As Bitmap
	x.Initialize(File.DirAssets,imgFile)
	gBtn.SetBackgroundImage(x)
	gBtn.Tag = x.Width & "x" & x.height
	Return gBtn
End Sub
Sub createImage(destination As Panel, imgFile As String,w As Int, Lft As Int,Top As Int) As ImageView
	Dim fileInfo As Map = pathinfo(imgFile)
	If fileInfo.Get("dirname") = "" Then fileInfo.Put("dirname",File.DirAssets)
	Private img As ImageView
	img.Initialize("")
	Private bmp As Bitmap
	If File.Exists(fileInfo.Get("dirname"),fileInfo.Get("basename")) Then
		bmp.Initialize(fileInfo.Get("dirname"),fileInfo.Get("basename"))
	Else
		bmp.InitializeMutable(100dip,100dip)
		Dim cnv As Canvas
		cnv.Initialize2(bmp)
		cnv.DrawColor(Colors.Red)
		img.Color = Colors.Red
	End If
	Dim wImg As Int = bmp.width
	If w > 0 Then wImg = w	' width imposed
	img.Bitmap = bmp.Resize(wImg,wImg/bmp.width*bmp.Height,True)
	If Top = -1 Then Top = (100%y - (wImg/bmp.width)*bmp.Height)/2
	If Lft = -1 Then Lft = (100%x - wImg)/2
	destination.AddView(img,Lft, Top, wImg,wImg/bmp.width*bmp.Height)
	Return img
End Sub
Sub borders(panel As View,bound As String) As Int	' returns 0 no border/shadow, 1 border, 2 shadow
	If bound = "" Then Return 0
	Dim canv As Canvas
	canv.Initialize(panel)
	Dim x() As String = Regex.Split("\s+",bound)
	Dim rect As Rect
	Select x(0)
		Case "border"
			Dim halfBorder As Int = borderLineWidth/2
			rect.Initialize(halfBorder,halfBorder,panel.Width-halfBorder,panel.Height-halfBorder)
			Dim colorLine As Int = Colors.ARGB(127,0,0,0)
			If x.Length = 2 Then colorLine = decodeColor(x(1))
			canv.DrawRect(rect,colorLine,False,borderLineWidth)
			Return 1
		Case "shadow"
			rect.Initialize(panel.Width-shadowWidth,0,panel.Width,panel.Height)
			canv.DrawRect(rect,Colors.ARGB(127,0,0,0),True,1dip)
			rect.Initialize(shadowWidth,panel.height-shadowWidth,panel.Width-shadowWidth,panel.Height)
			canv.DrawRect(rect,Colors.ARGB(127,0,0,0),True,1dip)
			rect.Initialize(panel.Width-shadowWidth,0,panel.Width,shadowWidth)
			canv.DrawRect(rect,Colors.Transparent,True,1dip)
			rect.Initialize(0,panel.height-shadowWidth,shadowWidth,panel.Height)
			canv.DrawRect(rect,Colors.Transparent,True,1dip)
			Return 2
	End Select
End Sub
Private Sub setDefaults(reset As Int)	' 0 for reset all > 0 is reset on tab
	For i = 0 To nElem - 1
		field = Elem.GetValueAt(i)
		If "*C*TAB*TITLE*I*".Contains("*" & field(0) & "*") Then Continue	' not fields
		If field(0) <> "B" Then
			Dim wdgl As Label = getFromViewMap(field(1),2)
			wdgl.TextColor = Colors.White
		End If
		If reset = 0 Or getFromViewMap(field(1),4) = currentTab Then
			If Defaults.ContainsKey(field(1)) Then 
				setValue(field(1),Defaults.Get(field(1)))
				If fh_Data.ContainsKey(field(1)) Then setValue(field(1),fh_Data.Get(field(1)))	' data from another section
			End If
		End If
	Next
End Sub
Sub extractRandom(xx() As String) As String() 	' xx(0) name, xx(1) defaults
	Dim retxx(2) As String = Array As String(xx(0),"")
	If Not(Elem.ContainsKey(xx(0))) Then
		Msgbox(xx(0) & " is not a widget","")
		Return retxx
	End If
	If xx.Length <> 2 Then 
		Dim Fields() As String = Elem.GetDefault(xx(0),"")	' if no defaults, take item list
		retxx(1) = Fields(5)
	Else
		retxx(1) = xx(1)
	End If
	Dim Match As Matcher
	Match = Regex.Matcher(re, retxx(1))
	If Match.Find Then
		retxx(1) =  Rnd(Match.Group(1),Match.Group(2) + 1)
	Else
		If retxx(1) <> "" Then
			Dim rString() As String = Regex.Split("\|",Regex.Replace("\|.*?:","|" & retxx(1),"|"))
			Dim rndx As Int = 0
			If rString.Length > 1 Then rndx = Rnd(1,rString.Length)
			retxx(1) = rString(rndx)
		End If
	End If
	Return retxx
End Sub
Private Sub getHeight(rows As Int) As Int	
	If rows < 2 Then Return widgetHeight
	Return baseHeight + 0.8 * charHeight*Max(1,rows) ' ex 5/10/19
End Sub
Sub mask(data As String) As String	' mask comma AND semicolon
	Dim s As String = data.Replace(",","#44")
	Return s.Replace(";","#59")
End Sub
Sub deMask(text As String)	As String
	Dim Match As Matcher = Regex.Matcher(reDeMask, text)
	Do While Match.Find
		If (Match.Match).ToUpperCase.CharAt(1) = "X" Then
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(2),16)))
		Else
			text = text.Replace(Match.Match,Chr(Bit.ParseInt(Match.Match.SubString(1),10)))
		End If
	Loop
	Return text
End Sub
Sub Left(s As String,l As Int) As String
If l < s.Length Then Return s.SubString2(0,l)
Return s
End Sub
Sub Right(s As String,l As Int) As String
If l < s.Length Then Return s.SubString(s.Length-l)
Return s
End Sub
Sub iIF(Cond As Boolean,First As Object,Second As Object) As Object
	If Cond Then Return First
	Return Second
End Sub
Private Sub insertlistDir(dir As String) As List
	Dim lst As List
	lst.Initialize
	Dim lst2 As List = File.ListFiles(dir)
	If lst2.IsInitialized Then
		If File.IsDirectory(dir,"") Then		
			lst.AddAll(lst2)
			lst.SortCaseInsensitive(True)
			If dir.indexOf2("/",1) > -1 Then lst.InsertAt(0,"..")
		End If
	End If
	Return lst
End Sub
Sub splitKeyValue(name As String,data As String) As List ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt(),key,value As String,k As Int 
	Dim lst As List
	lst.Initialize
	If data.Length > 0 Then
		dt = Regex.Split("\|", data)
		For j = 0 To dt.Length - 1
			If dt(j).IndexOf(":") < 0 Then dt(j)=dt(j) & ":" & dt(j)
			k = dt(j).IndexOf(":")
			key = dt(j).SubString2(0,k)
			value = dt(j).SubString(k+1)
			mapValues.Put(name & value,key)
			If value <> key Then mapValues.Put(name & key,value)	' 3 may 2019
			lst.add(value)
		Next
	End If
	Return lst
End Sub
Private Sub RadioButton_CheckedChange(chk As Boolean)
	rdbCommon(Sender)
End Sub
private Sub RDBbuttons_Click
	Dim img As ImageView = Sender
	Dim rdb As RadioButton = img.tag
	rdb.Checked = True
	rdbCommon(rdb)
End Sub
Private Sub rdbCommon (rdb As RadioButton)
	Dim wdgl As Label = getFromViewMap(rdb.Tag,2)
	wdgl.TextColor = Colors.White	' in case of required
	Dim a() As Object = widgetRef.get(rdb.Tag)
	a(3) = rdb
	widgetRef.Put(rdb.tag,a)
	rdb.Checked = True
	handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
End Sub
Private Sub Buttons_Click		' *** exit routin
	Dim btnView As View = Sender
	Dim btnTag As String = btnView.Tag
	handleEvents(Array As Object (btnView.tag,"CLICK",btn))	
	If btnTag = "Reset" Then 
		setDefaults(iIF(nTabs > 0,currentTab,0))
		handleEvents(Array As Object ("fh_reset","Reset"))
	Else If  btnTag = "Cancel" Then
		handleEvents(Array As Object ("fh_cancel","End"))
		fh_Data.Put("fh_button", btnTag)
		fh_panel.RemoveView
		fh_groundPanel.RemoveView
		CallSubDelayed2("","fh_answer",fh_Data)
	Else
		If getFromViewMap(btnTag,3) <> "" Then	' there is a callback
			Dim	fh_CallBackSub() As String = Regex.Split("\.",getFromViewMap(btnTag,3))		' split module and sub
			If fh_CallBackSub.Length = 2 Then 
				CallSubDelayed2(fh_CallBackSub(0),fh_CallBackSub(1),btnTag)
			Else
				CallSubDelayed2(fh_module,fh_CallBackSub(0),btnTag)
			End If
			Return
		End If
		If CheckErrors(btnTag) Then
			If fh_yesToExit Then
				For i = 0 To hiddensMap.Size - 1' add hidden fields
					fh_Data.Put(hiddensMap.GetKeyAt(i),hiddensMap.GetValueAt(i))
				Next
				handleEvents(Array As Object ("fh_end","End"))
				fh_panel.RemoveView
				fh_groundPanel.RemoveView
				CallSubDelayed2("","fh_answer",fh_Data)
			End If
		End If
	End If
End Sub
Private Sub CheckErrors(btnTag As String)	As Boolean	' for button end spinner aka button list
	Private signal As String = ""
	For i = 0 To nElem -1
		field = Elem.GetValueAt(i)
		If "B*C*TAB*TITLE*I*".Contains(field(0) & "*") Then Continue	' not fields
		Dim wdgtValue As String = valueOf(field(1))
		If checks.ContainsKey(field(1)) Then
			Dim s As String = CheckField(field,wdgtValue)
			If s <> "" Then signal = signal & "," & s
		End If
		fh_Data.Put(field(1),wdgtValue)	' set wiew value
	Next
	If signal <> "" Then 
		ToastMessageShow(signal.SubString(1),True)
		Return False
	End If
	fh_Data.Put("fh_button",btnTag)
	Return True
End Sub
Sub getLabelHandle(Name As String) As Label
	Return getFromViewMap(Name,2)
End Sub
Sub CheckField(f() As String, wdgtValue As String) As String
	Dim wdgl As Label = getFromViewMap(f(1),2)
	wdgl.TextColor = Colors.White
	If checks.ContainsKey(f(1)) Then
		Private check As Map = checks.Get(f(1))
		For Each k As String In check.Keys
			Dim strCheck(3) As String =  check.Get(k)
			Dim operand As String = strCheck(1)
			Dim operator As String = strCheck(0)
			If operator <> "is" Then
				If widgetRef.ContainsKey(operand) Then operand = valueOf(operand)	' compare with field
				If Not(compare(numericTypes.GetDefault(f(0),False),valueOf(f(1)),operator,operand)) Then
					Return setError(wdgl,strCheck(2))
				End If
			Else			
				If operand.ToLowerCase() = "required" Then
					If wdgtValue = "" Then Return setError(wdgl,strCheck(2))
				Else If operand.ToLowerCase() = "date" Then
					Try
						DateTime.DateParse(wdgtValue)
					Catch
						Return setError(wdgl, LastException)
					End Try
				else If operand.ToLowerCase() = "mail" Then
					If Not(Regex.IsMatch(reMail,wdgtValue)) Then
						Return setError(wdgl,strCheck(2))
					End If
				Else 		' my be a regular expression
					If Not(Regex.IsMatch(deMask(operand),wdgtValue)) Then Return setError(wdgl,strCheck(2))
				End If
			End If
		Next
	End If
	Return ""
End Sub
Private Sub compare(Numeric As Boolean,wdgtValue As String, operator As String, operand As String) As Boolean
	Dim cfr As Int = 1	' means equal
	If Numeric Then		' numeric field
		If wdgtValue = "" Then Return True			' no data - no compare
		If Not(IsNumber(operand)) Then Return True	' no data - no compare
		If wdgtValue > operand Then cfr = 2
		If wdgtValue < operand Then cfr = 4
	Else
		Dim cfr As Int = wdgtValue.CompareTo(operand)
		If cfr > 0 Then cfr = 2
		If cfr < 0 Then cfr = 4
		If cfr = 0 Then cfr = 1
	End If
	If Bit.And(cfr,comparator.Get(operator)) = 0 Then Return False
	Return True
End Sub
Private Sub setError(l As Label,s As String) As String
	l.TextColor = Colors.Red
	Return l.tag & ": " & s
End Sub
Private Sub handleEvents(parms() As Object) As Boolean
	If fh_handleSub <> "" Then CallSub2(fh_module,fh_handleSub,parms)
End Sub
Private Sub Combos_ItemClick(Position As Int, Value As Object)
	Dim cb As Spinner = Sender
	Dim wdgl As Label = getFromViewMap(cb.Tag,2)
	wdgl.TextColor = Colors.White	' in case of required
	Dim typeWidget As String = getViewType(cb.Tag)
	handleEvents(Array As Object (cb.Tag,"CLICK",cb,mapValues.GetDefault(cb.Tag & cb.SelectedItem,"")))
	If typeWidget = "F" Then
		Dim dir As String = getFromViewMap(cb.Tag,3)	' folder
		Dim lblFile As Label = tipsMap.get(cb.Tag)
		If Value = ".." Then
			Dim fileInfo As Map = pathinfo(dir)
			dir = fileInfo.Get("dirname")
			Value = ""
		End If
		If Not(dir.EndsWith("/")) And Value <> "" Then dir = dir & "/"
		If File.IsDirectory(dir, Value) = True Then
			If Not(File.ListFiles(dir & Value).IsInitialized) Then
				ToastMessageShow(dir & Value & " folder not accessible",False)
			Else
				cb.clear
				cb.AddAll(insertlistDir(dir & Value))
				setInMap(cb.Tag,3,dir & Value)
				cb.SelectedIndex = 0
				lblFile.Text = dir & Value
			End If
		End If
	Else If typeWidget = "CMX" Then
		Dim txt As EditText = iIF(widgetRef.ContainsKey(cb.tag),getFromViewMap(cb.tag,0),-1)
		If Not(txt.Text.Contains(Value)) Then
			If txt.Text <> ""  Then  txt.Text =  txt.Text & Chr(10)
			txt.Text = txt.Text & Value
		End If
	Else If typeWidget = "CMT" Then
		setValue(cb.Tag,Value)
	Else If typeWidget = "CMB" And typeForm = "C" Then		' only one spinner
		handleEvents(Array As Object ("fh_end","End"))
		fh_Data.Put(field(1),valueOf(field(1)))
		fh_panel.RemoveView
		fh_groundPanel.removeView
		fh_isRunning = False
		If fh_returnSub = "" Then Return
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
	End If
End Sub
Private Sub txt_EnterPressed
	'txt = Sender
	'fh_module.handleEvents(Sender,Array As Object (txt.tag,"ENTER"))
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
	focusTxt = Sender
	handleEvents(Array As Object (focusTxt.tag,iIF(HasFocus,"FOCUS","LFOCUS"),Sender,focusTxt.text))
	If HasFocus Then
		If tipsMap.ContainsKey(focusTxt.Tag) Then ToastMessageShow(tipsMap.get(focusTxt.Tag),False)
		If getViewType(focusTxt.Tag) = "T" Then startVoiceRec
	Else
		Dim signal As String = CheckField(Elem.Get(focusTxt.Tag),focusTxt.Text)	' checks data
		If signal <> "" Then
			ToastMessageShow(signal,True)
		End If		
	End If
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	handleEvents(Array As Object (ckb.tag,"CKB",ckb,iIF(Checked,"1","0")))
End Sub
Private Sub Slide_ValueChanged (Value As Int, UserChanged As Boolean)
	Dim slideValue As Double,dec As Int,txtSlider As EditText
	Dim sld As SeekBar = Sender
	Dim wdgl As Label = getFromViewMap(sld.Tag,2)
	wdgl.TextColor = Colors.White	' in case of required
	txtSlider = getFromViewMap(sld.Tag,3)
	If getFromViewMap(sld.Tag,1) = "QS" Then
		Private listQs As List = Limits.Get(sld.Tag)
		txtSlider.text = listQs.Get(Value)
		slideValue = Value
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,txtSlider.Text,getFromViewMap(sld.tag,3)))
	Else
		If UserChanged Or txtSlider.Text <> "" Or Defaults.Get(sld.Tag) <> "" Then
			slideValue = Limits.get(sld.Tag & "Min") + Value * (Limits.get(sld.Tag & "Delta"))/100
			dec = Floor(Logarithm(Limits.get(sld.Tag & "Delta"),10))	' delta
			txtSlider.text = NumberFormat(slideValue,1,0)
			If dec < 3 Then txtSlider.text = NumberFormat(slideValue,1,-dec+2)
		End If
		handleEvents(Array As Object (sld.Tag,"SLIDE",sld,txtSlider.Text,getFromViewMap(sld.tag,3)))
	End If
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
    	k = msk.IndexOf(mtc.Match)
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0)) 
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub TypeOf(obj As Object) As String
Dim t() As String = Regex.Split("\.",GetType(obj))
Return t(t.Length - 1)
End Sub
Private Sub fillString(n As Int) As String
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then
		aWdg(pos) = val
	End If
	widgetRef.Put(fld,aWdg)
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":"","extension":"","filename":"","basename":"")
	Dim k As Int = dir.LastIndexOf("/")
	If k >= 0 Then	fInfo.Put("dirname",Left(dir,k))
	Dim fl As String = dir.SubString(k+1)
	fInfo.Put("basename",fl)
	k = fl.LastIndexOf(".")
	fInfo.Put("filename",fl)
	If k >= 0 Then 
		fInfo.Put("filename",Left(fl,k))
		fInfo.Put("extension",fl.SubString(k+1))
	End If
	Return fInfo
End Sub
Sub startVoiceRec()
'	VR.Listen 'calls the voice recognition external activity
End Sub
Sub addCheck(condition As String,signal As String)
	Matcher1 = Regex.Matcher2("(.+?)\s*(=|<=|>=|<>|>|<|is)\s*(.*)",Regex.CASE_INSENSITIVE,condition)
	If Matcher1.Find Then
		Dim widgetName As String = Matcher1.Group(1)
		Dim operator As String = Matcher1.Group(2).TolowerCase
		Dim operand = As String Matcher1.Group(3)
		Private a As Map = CreateMap()
		a.Initialize
		If checks.ContainsKey(widgetName) Then a = checks.Get(widgetName)
		a.Put(operator & operand,Array As String(operator,operand,signal))
		checks.Put(widgetName,a)
	End If
End Sub
Sub removeCheck(condition As String)
	Matcher1 = Regex.Matcher2("(.+?)\s*(=|<=|>=|<>|>|<|is)\s*(.*)",Regex.CASE_INSENSITIVE,condition)
	If Matcher1.Find Then
		Dim widgetName As String = Matcher1.Group(1)
		Dim operator As String = Matcher1.Group(2).ToUpperCase
		Dim operand = As String Matcher1.Group(3)
		Private a As Map = CreateMap()
		a.Initialize
		If checks.ContainsKey(widgetName) Then a = checks.Get(widgetName)
		If a.ContainsKey(operator & operand) Then
			a.Remove(operator & operand)
			checks.Put(widgetName,a)
		End If
	End If
End Sub
Sub VR_Result (Success As Boolean, Texts As List)
	If Success = True Then
		Dim a() As Object = Array As Object(focusTxt.tag,"VREND",focusTxt,Texts.get(0))
		handleEvents(a)
		focusTxt.text = iIF(focusTxt.text = "",  a(3), focusTxt.text & Chr(13) & Chr(10) &  a(3))
		startVoiceRec
	End If
End Sub
Sub enable(Name As String)
	SetWidget(Name,"Enable")
End Sub
Sub Disable(Name As String)
	SetWidget(Name,"Disable")
End Sub
Private Sub SetWidget(Name As String, option As String)
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))	
	If aWdg.Length = 1 Then Return	' key exist?
	Dim v As View = aWdg(0)
	Dim opt As String = option.ToLowerCase
	Select opt
		Case "enable","disable"
			If TypeOf(v) = "Button" Or TypeOf(v) <> "BALayout" Then 
				v.Enabled = iIF(opt = "enable",True,False)
			Else
				pnl = aWdg(0)
				For i = 0 To pnl.NumberOfViews -1
					pnl.GetView(i).Enabled = iIF(opt = "enable",True,False)
				Next
			End If
	End Select
End Sub
Sub getHandle(Name As String) As Object
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))
	Return aWdg(0)
End Sub
Private Sub getFromViewMap(fld As String,pos As Int) As Object	' From field widget map parameters field, position
	Dim aWdg() As Object = widgetRef.GetDefault(fld,Array As Object(0))
	If pos < aWdg.Length Then Return aWdg(pos)
	Return 0
End Sub
Sub getViewType(Name As String) As String
	Return getFromViewMap(Name,1)
End Sub
Sub getValue(Name As String) As String
	Return valueOf(Name)
End Sub
Sub valueOf(Name As String) As String
	If Name.StartsWith("fh_") Then
		valueOf(Name.SubString(3))
		Return mapValues.GetDefault(Name.SubString(3) & valueOf(Name.SubString(3)),"")
	End If
	If Not(fh_isRunning) Then Return fh_Data.GetDefault(Name,"")	' in case of form closed
	Dim a() As Object
	If widgetRef.ContainsKey(Name) Then
		a = widgetRef.get(Name)
		Select a(1)		' widget type
			Case "TAB","TITLE"
			Case "CMB","F"
				Dim cmb As Spinner = a(0)
				If a(1) = "CMB" Then Return mapValues.GetDefault(Name & cmb.SelectedItem,"")
				Return a(3) & "/" & iIF(cmb.SelectedItem = "..","",cmb.SelectedItem)
			Case "CKB"
				Dim chk As CheckBox = a(0)
				Return (iIF(chk.Checked,"1","0"))
			Case "S","QS"		' SeekBar
				Dim txt As EditText = a(3)
				If a(1) = "S" Then Return txt.text
				Return mapValues.get(Name & txt.text)
			Case "U"		' Unmodifiable
				Dim uLbl As Label = a(0)
				Return uLbl.text
			Case "R"		' RadioButton
				If a(3) = 0 Then Return ""
				Dim rdb As RadioButton = a(3)
				Return mapValues.get(Name & rdb.text)
			Case "B"
				Return Name
			Case "H"
				Return hiddensMap.GetDefault(Name,"")
			Case Else 		' text Views also CMT combo text
				Dim wdgT As EditText = a(0)
				If a(1) = "CMT" Then Return mapValues.GetDefault(Name & wdgT.text,wdgT.text)
				Return wdgT.text
		End Select	
	End If
	Return ""
End Sub
Sub implode(sep As String,obj As List) As String
	Return implodeFrom(sep,obj,0,obj.Size)
End Sub
Sub implodeFrom(sep As String, obj As List, From As Int, At As Int) As String
	Dim implStr As String = ""
	For j = obj.size -1 To From Step -1	' delete last empty items 
		If obj.Get(j) <> "" Then Exit
	Next
	For i = From To Min(At,j)
	     implStr =  implStr & sep & obj.Get(i)
	Next
	If implStr.Length > 0 Then Return implStr.SubString(1)
	Return ""
End Sub
Sub setValue(Name As String,Value As String)
'	Log(Name & TAB & getFromViewMap(Name,0))
	Dim wdg As Object = iIF(widgetRef.ContainsKey(Name),getFromViewMap(Name,0),-1)
	If wdg = -1 Then Return	' no field
	Select getViewType(Name)
		Case "CMB"
			Dim cmb As Spinner = wdg
			cmb.SelectedIndex = cmb.IndexOf(Value)
			If cmb.SelectedIndex = -1 Then cmb.SelectedIndex = cmb.IndexOf(mapValues.GetDefault(Name & Value,""))
		Case "CMT","CMX"
			Dim cmb As Spinner = getFromViewMap(Name,3)
			Dim txt As EditText = wdg
			txt.Text = Value	
			cmb.SelectedIndex = iIF(cmb.IndexOf(Value) > - 1,cmb.IndexOf(Value),0)		
		Case "F"
			Dim cmb As Spinner = wdg
			Dim fileInfo As Map = pathinfo(Value)
			Dim dir As String = fileInfo.Get("dirname")
			Dim fl As String = fileInfo.Get("basename")
			If dir = "" Then dir = File.DirRootExternal
			Dim lblFile As Label = tipsMap.Get(Name)
			lblFile.Text = dir
			cmb.Clear
			cmb.addall(insertlistDir(dir))
			setInMap(Name,3,dir)
			cmb.SelectedIndex = cmb.IndexOf(fl)
		Case "S"
			Dim sld As SeekBar = wdg
			Dim txt As EditText = getFromViewMap(sld.Tag,3)
			If IsNumber(Value) Then
				sld.Value = (Value - Limits.get(sld.Tag & "Min"))*100/(Limits.get(sld.Tag & "Max") - Limits.get(sld.Tag & "Min"))
				txt.Text = Value
			Else
				sld.Value = 0	' Limits.Get(Name & "Min")	' set un.
				txt.Text = ""
			End If
		Case "QS"
			Dim sld As SeekBar = wdg
			Dim txt As EditText = getFromViewMap(sld.Tag,3)
			Private listQs As List = Limits.Get(Name)
			listQs.IndexOf(Value)
			sld.Value = listQs.IndexOf(Value)
		Case "T","N","DN","IN","P","TIME","DATE"
			Dim txt As EditText = wdg
			field = Elem.Get(Name)
			If field(0) = "DATE" And Value.ToLowerCase = "now" Then
				addCheck(field(1) & " is Date","Incorrect date")
				If field(5) <> "" Then
					DateTime.DateFormat = field(5)
					addCheck(field(1) & " is ^" & field(5).Replace("d","\d").Replace("M","\d").Replace("y","\d") & "$","Incorrect date")
				End If
				txt.text = DateTime.Date(DateTime.Now)
			Else
				txt.text = Value				
			End If
		Case "CKB"
			Dim chk As CheckBox = wdg
			chk.Checked = iIF(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "U","C"
			Dim uLbl As Label = wdg
			uLbl.text = Value
		Case "R"
			pnl = getFromViewMap(Name,0)
			Dim v As View
			setInMap(Name,3,0)
			For i = 0 To pnl.NumberOfViews -1
				v = pnl.GetView(i)
				If TypeOf(v) = "RadioButton" Then
					Dim rdb As RadioButton = pnl.GetView(i)
					rdb.Checked = False
					If rdb.text = Value Or rdb.text = mapValues.GetDefault(Name & Value,"") Then 
						rdb.Checked = True
						setInMap(Name,3,rdb)
					End If
				End If
			Next
		Case "H"
			hiddensMap.Put(Name,Value)
		Case "B"
			Dim btnx As View = wdg
			btnx.Enabled = iIF(Left(Value,3).ToLowerCase = "dis",False,True)
	End Select
	handleEvents(Array As Object (Name,"SETVALUE",wdg,Value))
End Sub
Sub decodeColor(C As String) As Int
	Dim Match As Matcher = Regex.Matcher(reHexaDecimal, C)
	If Not(Match.Find) Then 
		Return colorsMap.GetDefault(C.ToLowerCase,-12566464) 	' FF404040  grey (-16 777 216 opaque black)‬
	Else
		C = (Left("FF000000",8-C.Length) & C)		' eight exadecimals digit
		If (C.SubString2(0,1)).compareto("7") > 0 Then Return - Power(2,31) + Bit.ParseInt("01234567".CharAt(Bit.ParseInt(C.SubString2(0,1),16)-8) & C.SubString(1),16)
		Return Bit.ParseInt(C,16)
	End If
End Sub
Sub CreateText(txt As EditText,fld() As String)
	If txt.IsInitialized Then txt.Invalidate
	txt.Initialize("txt")
	txt.Padding = padding	' Array As Int(4dip,5dip,2dip,5dip)
	txt.Gravity = Bit.Or(Gravity.TOP, Gravity.Left)
	backgroundDrawable.Initialize(Colors.ARGB(63,255,255,255), 3dip)
	fhMap_ColorDrawable.Put(fld(1),backgroundDrawable)
	txt.Background = fhMap_ColorDrawable.get(field(1))
	txt.Background = backgroundDrawable
	txt.TextSize = 12
	txt.Tag = fld(1)
	txt.InputType = textAttributes.GetDefault(fld(0),Bit.Or(1,16384))	' 14 April 2019 default capitalize sentences
	If field(3) > charPerRow Then txt.InputType = Bit.Or(txt.InputType,131072)	' multiline 16 April 2019
End Sub
Sub CreateCSLabel(Text As String, selected As Boolean) As CSBuilder
	Dim cs As CSBuilder
	If selected Then Return cs.Initialize.Underline.Color(Colors.white).Append(Text).PopAll
	Return cs.Initialize.Color(Colors.LightGray).Append(Text).PopAll
End Sub
Sub Createlabel(txt As String,Size As Int, event As String) As Label
	Dim lbl As Label
	lbl.Initialize(event)
	lbl.Padding = Array As Int (3dip, 0, 3dip, 0)
	lbl.TextSize = Size
	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.LEFT)
	lbl.Text = txt
	Return lbl
End Sub
Sub createTitle(title As String) As Label
	Dim t() As String = Regex.Split("/", title & "///*")
	Dim lbl As Label = Createlabel(t(1),20,"")
	lbl.Typeface = Typeface.DEFAULT_BOLD
	lbl.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
	If t(2) <> "" Then 
		lbl.Color = decodeColor(t(2))
	End If
	If t(3) <> "" Then lbl.TextColor = decodeColor(t(3))
	widgetRef.Put(t(0),Array As Object (lbl,"TITLE"))
	Return lbl
End Sub
Sub createTriangle(w As Int, h As Int) As Bitmap
	Private bmp As Bitmap
	bmp.InitializeMutable(w,h)
	Dim cnv As Canvas
	cnv.Initialize2(bmp)
	Dim p As Path
	p.Initialize(5dip, 5dip)
	p.LineTo(w/2, h-5dip)
	p.LineTo(w-5dip, 5dip)
	p.LineTo(5dip,5dip)
	cnv.DrawPath(p, Colors.ARGB(63,0,0,0), True, 1)
	Return bmp
End Sub
Sub createGradient(color As String) As GradientDrawable	
	Dim grad As GradientDrawable
	Dim cols(2) As Int
	If color = "" Then color = "FF404040 FF404040"
	Dim prms() As String = Regex.split("[ ]+",color & " * *")	'force three items (almosT)
	If prms.Length = 3 Then prms(1) = prms(0)
	If prms.Length < 5 Then prms(2) = "TOP_BOTTOM"
	cols(0) = decodeColor(prms(0))
	cols(1) = decodeColor(prms(1))
	grad.Initialize(prms(2),cols)
	Return grad
End Sub
Sub onglets_Click	
	Dim lbl As Label = Sender
	If lbl.tag <> currentTab Then
		fh_panels(currentTab).Visible = False
		lbl.Text = CreateCSLabel(tabAttribs(lbl.tag).caption,True)
		lbl.invalidate
		tabAttribs(currentTab).lbl.Text = CreateCSLabel(tabAttribs(currentTab).caption,False)
		fh_panels(lbl.Tag).Visible = True
		handleEvents(Array As Object ("TAB" & lbl.tag,"OPEN","TAB" & currentTab))
		currentTab = lbl.tag
	End If
End Sub
Sub topAfterView(aV As View,v As View)' center after view and possibly reduce
	v.Top = aV.Top+(aV.Height - v.Height)*0.5
	If aV.Left+aV.Width+v.width+10dip > 99%x Then	' 29 4 2019
		aV.Width = aV.Width - 28dip
		v.Left = v.Left-37dip
		aV.Invalidate
	End If
	If TypeOf(aV) = "SeekBar" Then v.Left = v.Left + 25dip
	v.invalidate
End Sub